#ifndef FEUFOLET_H_INCLUDED
#define FEUFOLET_H_INCLUDED

#include <iostream>
#include <SDL/SDL.h>

///Développeur: Jovian Hersemeule
///Dernière mise à jour le: 19/05/2014
///Objet: nouvelle fonction: create feu follet

/*
==La fonction createFeuFolet==
    +Arguments:
        -Un entier pour le rayon de la boule
        -Un Uint 32 pour la couleur
    +Renvoi:
        -Une SDL surface avecl le feu follet
    +Descriptif:
        Permet de créer un effet de dégradé circulaire; ressemeblant à un feu follet.
==La fonction blitFeuFolet==
    +Arguments:
        -Une SDL_Surface pour bliter le feu
        -Un int donnant la coordonnée en abscisse
        -Un int pour l'ordonnée ATTENTION !!! Coordonnées du carré, pas à partir du centre !
        -Un entier pour le rayon de la boule
        -Un Uint 32 pour la couleur
        FACULTATIF - Un short (petit int) de transparence (0 VISIBLE, 255 NON VISIBLE)
    +Renvoi:
        -Une SDL surface avec le feu follet
    +Descriptif:
        Permet de créer un effet de dégradé circulaire; ressemeblant à un feu follet.

*/

SDL_Surface* createFeuFolet(int rayon, Uint32 couleurRGB);

void blitFeuFollet(SDL_Surface* support, int x, int y, int rayon, Uint32 couleurRGB, short opacite=0);

int carre(int nombre);

#endif // FEUFOLET_H_INCLUDED
